#ifndef _QUEUE_H_
#define _QUEUE_H_

#define QUEUE_SIZE 256

typedef struct {
  char e[QUEUE_SIZE][4096];
  int read;
  int write;
  volatile int size;
  void *cond;
  void *mutex;
  volatile int alive;
} queue_t;

void init_queue(queue_t *q);
void free_queue(queue_t *q);

void enqueue(queue_t *q, char *buf);
void dequeue(queue_t *q, char *buf);

void kill_queue(queue_t *q);

#endif /* _QUEUE_H_ */
